


close all;
clear all;
clc;

% set fwd_kinematics q 
n = 10;

q1 = linspace(120,140,n)*pi/180;
q2 = linspace(45,65,n)*pi/180;
q3 = 0;

for i = 1:n

    x(i,:) = [q1(i) q2(i) q3 q1(i) q2(i) q3 q1(i) q2(i) q3 q1(i) q2(i) q3];
    [p11(i,:),p12(i,:),p13(i,:),p14(i,:),p15(i,:),p16(i,:),p17(i,:),...
     p21(i,:),p22(i,:),p23(i,:),p24(i,:),p25(i,:),p26(i,:),p27(i,:)...
     p31(i,:),p32(i,:),p33(i,:),p34(i,:),p35(i,:),p36(i,:),p37(i,:)...
     p41(i,:),p42(i,:),p43(i,:),p44(i,:),p45(i,:),p46(i,:),p47(i,:)] = test_fwd_kinematics(x(i,:));
    
end

%%
for i = 1:n

% plot first leg
    plot3([p11(i,1),p12(i,1)],[p11(i,2),p12(i,2)],[p11(i,3),p12(i,3)]);
     hold on
    plot3([p12(i,1),p14(i,1)],[p12(i,2),p14(i,2)],[p12(i,3),p14(i,3)]);
    plot3([p12(i,1),p13(i,1)],[p12(i,2),p13(i,2)],[p12(i,3),p13(i,3)]);
    plot3([p13(i,1),p15(i,1)],[p13(i,2),p15(i,2)],[p13(i,3),p15(i,3)]);
    plot3([p14(i,1),p15(i,1)],[p14(i,2),p15(i,2)],[p14(i,3),p15(i,3)]);
    plot3([p15(i,1),p16(i,1)],[p15(i,2),p16(i,2)],[p15(i,3),p16(i,3)]);
    plot3([p16(i,1),p17(i,1)],[p16(i,2),p17(i,2)],[p16(i,3),p17(i,3)]);
    
    plot3 (p11(i,1),p11(i,2),p11(i,3),'o');
    plot3 (p12(i,1),p12(i,2),p12(i,3),'o');
    plot3 (p13(i,1),p13(i,2),p13(i,3),'o');
    plot3 (p14(i,1),p14(i,2),p14(i,3),'o');
    plot3 (p15(i,1),p15(i,2),p15(i,3),'o');
    plot3 (p16(i,1),p16(i,2),p16(i,3),'o');
    plot3 (p17(i,1),p17(i,2),p17(i,3),'o');
    
  
xlabel('x');
ylabel('y');
zlabel('z');
xlim([-0.35 0.35]);

% plot second leg
    plot3([p21(i,1),p22(i,1)],[p21(i,2),p22(i,2)],[p21(i,3),p22(i,3)]);
 
    plot3([p22(i,1),p24(i,1)],[p22(i,2),p24(i,2)],[p22(i,3),p24(i,3)]);
    plot3([p22(i,1),p23(i,1)],[p22(i,2),p23(i,2)],[p22(i,3),p23(i,3)]);
    plot3([p23(i,1),p25(i,1)],[p23(i,2),p25(i,2)],[p23(i,3),p25(i,3)]);
    plot3([p24(i,1),p25(i,1)],[p24(i,2),p25(i,2)],[p24(i,3),p25(i,3)]);
    plot3([p25(i,1),p26(i,1)],[p25(i,2),p26(i,2)],[p25(i,3),p26(i,3)]);
    plot3([p26(i,1),p27(i,1)],[p26(i,2),p27(i,2)],[p26(i,3),p27(i,3)]);
    
    plot3 (p21(i,1),p21(i,2),p21(i,3),'o');
    plot3 (p22(i,1),p22(i,2),p22(i,3),'o');
    plot3 (p23(i,1),p23(i,2),p23(i,3),'o');
    plot3 (p24(i,1),p24(i,2),p24(i,3),'o');
    plot3 (p25(i,1),p25(i,2),p25(i,3),'o');
    plot3 (p26(i,1),p26(i,2),p26(i,3),'o');
    plot3 (p27(i,1),p27(i,2),p27(i,3),'o');
    
     
xlabel('x');
ylabel('y');
zlabel('z');
xlim([-0.35 0.35]);
% plot third leg
    plot3([p31(i,1),p32(i,1)],[p31(i,2),p32(i,2)],[p31(i,3),p32(i,3)]);
 
    plot3([p32(i,1),p34(i,1)],[p32(i,2),p34(i,2)],[p32(i,3),p34(i,3)]);
    plot3([p32(i,1),p33(i,1)],[p32(i,2),p33(i,2)],[p32(i,3),p33(i,3)]);
    plot3([p33(i,1),p35(i,1)],[p33(i,2),p35(i,2)],[p33(i,3),p35(i,3)]);
    plot3([p34(i,1),p35(i,1)],[p34(i,2),p35(i,2)],[p34(i,3),p35(i,3)]);
    plot3([p35(i,1),p36(i,1)],[p35(i,2),p36(i,2)],[p35(i,3),p36(i,3)]);
    plot3([p36(i,1),p37(i,1)],[p36(i,2),p37(i,2)],[p36(i,3),p37(i,3)]);
    
    plot3 (p31(i,1),p31(i,2),p31(i,3),'ok');
    plot3 (p32(i,1),p32(i,2),p32(i,3),'ok');
    plot3 (p33(i,1),p33(i,2),p33(i,3),'ok');
    plot3 (p34(i,1),p34(i,2),p34(i,3),'ok');
    plot3 (p35(i,1),p35(i,2),p35(i,3),'ok');
    plot3 (p36(i,1),p36(i,2),p36(i,3),'ok');
    plot3 (p37(i,1),p37(i,2),p37(i,3),'ok');
    
 
xlabel('x');
ylabel('y');
zlabel('z');
xlim([-0.35 0.35]);

% plot fourth leg
    plot3([p41(i,1),p42(i,1)],[p41(i,2),p42(i,2)],[p41(i,3),p42(i,3)]);

    plot3([p42(i,1),p44(i,1)],[p42(i,2),p44(i,2)],[p42(i,3),p44(i,3)]);
    plot3([p42(i,1),p43(i,1)],[p42(i,2),p43(i,2)],[p42(i,3),p43(i,3)]);
    plot3([p43(i,1),p45(i,1)],[p43(i,2),p45(i,2)],[p43(i,3),p45(i,3)]);
    plot3([p44(i,1),p45(i,1)],[p44(i,2),p45(i,2)],[p44(i,3),p45(i,3)]);
    plot3([p45(i,1),p46(i,1)],[p45(i,2),p46(i,2)],[p45(i,3),p46(i,3)]);
    plot3([p46(i,1),p47(i,1)],[p46(i,2),p47(i,2)],[p46(i,3),p47(i,3)]);
    
    plot3 (p41(i,1),p41(i,2),p41(i,3),'o');
    plot3 (p42(i,1),p42(i,2),p42(i,3),'o');
    plot3 (p43(i,1),p43(i,2),p43(i,3),'o');
    plot3 (p44(i,1),p44(i,2),p44(i,3),'o');
    plot3 (p45(i,1),p45(i,2),p45(i,3),'o');
    plot3 (p46(i,1),p46(i,2),p46(i,3),'o');
    plot3 (p47(i,1),p47(i,2),p47(i,3),'o');
    
    hold off
xlabel('x');
ylabel('y');
zlabel('z');

xlim([-0.35 0.35]);
pause(0.2)

end


